/* This implements a vector, or a point stored as polar coordinates. */
typedef struct {
  double radians;
  double len;
} vector;

/* This implements a Cartesian coordinate point. */
typedef struct {
  double x;
  double y;
} cartesian;

/* This implements a Cartesian point with integer-only values. */
typedef struct {
  int x;
  int y;
} cart_int;

void fill_vector(double, double, vector *);
void fill_cartesian(double, double, cartesian *);
cartesian * vec_to_cart(cartesian *, vector *);
vector * cart_to_vec(vector *, cartesian *);
void vector_add(vector *, vector *);
void vector_negate(vector *);
void vector_bounce(vector *, double);
void bounce_with_friction(vector *, double);
